
//-----------------------------------------------------------------------------
// Copyright (c) Terametrix Systems International Incorporated, 1995
//-----------------------------------------------------------------------------

#include <windows.h>
#include <windowsx.h>
#include "winsock.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <dos.h>

BOOL CALLBACK _export WndProc ( HWND, UINT, WPARAM, LPARAM );

char TitleString[]="WinSock DNS";

char gstring[80];
unsigned short ra;
unsigned long la;

WSADATA wsad;
HANDLE hand;

//-----------------------------------------------------------------------------
int PASCAL WinMain ( HINSTANCE hinstance, HINSTANCE hprev, LPSTR cmdline, int nCmdShow )
{
    int retval;
    HWND hwnd;
    if(hprev!=NULL)
    {
        hwnd=FindWindow(NULL,TitleString);
        if(hwnd!=NULL) BringWindowToTop(hwnd);
        else MessageBox(NULL,"Application Already Running",TitleString,MB_OK);
        return(NULL);
    }
    if(WSAStartup(0x0101,&wsad))
    {
        MessageBox(NULL,"WSAStartup() failed",TitleString,MB_OK);
        return(NULL);
    }
    retval=DialogBox(hinstance,"MainDialog",0,WndProc);
    if(retval==-1)
    {
        MessageBox(NULL,"Could not create main window!",TitleString,MB_OK);
        return(FALSE);
    }
    WSACleanup();
    return(TRUE);
}
//-----------------------------------------------------------------------------
void addstring ( HWND hwnd, char *s )
{
    if(s[0]==0) return;
    if(s==NULL) return;
    //SendDlgItemMessage(hwnd,102,EM_SETSEL,0,MAKELONG(0,-1));
    SendDlgItemMessage(hwnd,102,EM_SETSEL,0,MAKELONG(-1,-1));
//    SendDlgItemMessage(hwnd,102,EM_SETSEL,0,MAKELONG(0xFFFE,0xFFFE));
    SendDlgItemMessage(hwnd,102,EM_REPLACESEL,0,(LPARAM)s);
}
//-----------------------------------------------------------------------------
void enable ( HWND hwnd, BOOL en )
{
    EnableWindow(GetDlgItem(hwnd,101),en);
    EnableWindow(GetDlgItem(hwnd,IDOK),en);
    EnableWindow(GetDlgItem(hwnd,103),en);
    EnableWindow(GetDlgItem(hwnd,IDCANCEL),en);
    if(en) SetFocus(GetDlgItem(hwnd,101));
}
//-----------------------------------------------------------------------------
BOOL CALLBACK _export WndProc( HWND hwnd, UINT message, WPARAM wparam, LPARAM lparam )
{
    RECT recta,rectb; //for centering window in WM_INITDIALOG
    struct hostent *host;
    unsigned long addr;

    switch(message)
    {
        case WM_INITDIALOG:
            //next three lines center the window on the screen
            GetWindowRect(GetDesktopWindow(),&recta);
            GetWindowRect(hwnd,&rectb);
            MoveWindow(hwnd,((recta.right-recta.left)>>1)-((rectb.right-rectb.left)>>1),((recta.bottom-recta.top)>>1)-((rectb.bottom-rectb.top)>>1),rectb.right-rectb.left,rectb.bottom-rectb.top,FALSE);
            SetWindowText(hwnd,TitleString);
            sprintf(gstring,"Winsock Version %u.%u\r\n",(wsad.wVersion>>8)&255,wsad.wVersion&255); addstring(hwnd,gstring);
            sprintf(gstring,"[%s]\r\n\r\n",wsad.szDescription); addstring(hwnd,gstring);
            return TRUE;
        case WM_COMMAND:
            switch (wparam)
            {
                case 103:
                    SendDlgItemMessage(hwnd,102,WM_SETTEXT,0,(LPARAM)"");
                    break;
                case IDOK:
                    SendDlgItemMessage(hwnd,101,WM_GETTEXT,80,(LPARAM)gstring);
                    if(!gstring[0]) break;
                    enable(hwnd,FALSE);
                    addr=inet_addr(gstring);
                    if(addr==INADDR_NONE) host=gethostbyname(gstring);
                    else host=gethostbyaddr((void *)&addr,4,PF_INET);
                    if(host==NULL)
                    {
                        //may want to do some error processing here
                        //WSAGetLastError();
                        addstring(hwnd," Not Found\r\n");
                        enable(hwnd,TRUE);
                        break;
                    }
                    addstring(hwnd,host->h_name);
                    if(host->h_addr_list!=NULL)
                    {
                        for(ra=0;host->h_addr_list[ra]!=NULL;ra++)
                        {
                            sprintf(gstring," %s",inet_ntoa(*((struct in_addr *)host->h_addr_list[ra])));
                            addstring(hwnd,gstring);
                        }
                    }
                    if(host->h_aliases!=NULL)
                    {
                        for(ra=0;host->h_aliases[ra]!=NULL;ra++)
                        {
                            addstring(hwnd," ");
                            addstring(hwnd,host->h_aliases[ra]);
                        }
                    }
                    addstring(hwnd,"\r\n");
                    enable(hwnd,TRUE);
                    break;
                case IDCANCEL:
                    EndDialog(hwnd,TRUE);
                    break;
            }
            return TRUE;
    }
    return FALSE;
}
//-----------------------------------------------------------------------------
// Copyright (c) Terametrix Systems International Incorporated, 1995
//-----------------------------------------------------------------------------

